<?php

ob_start();

$height = $argv[1];
$url = $argv[2];
$error_message = '';

$proxy_host = $argv[3];
$proxy_port = $argv[4];

$tries = 0;

define('MAGPIE_DIR', 'magpie/');
define('MAGPIE_CACHE_ON', true);
define('MAGPIE_CACHE_AGE', 5);

require_once(MAGPIE_DIR.'rss_fetch.inc');

if (substr($url, 0, 7) == 'feed://')
    $url = 'http://'.substr($url, 7);
if (substr($url, 0, 7) != 'http://' && substr($url, 0, 8) != 'https://')
    $url = 'http://'.$url;

function error_handler($errno, $errmsg, $filename, $linenum, $vars)
{
    if (in_array($errno, array(E_USER_ERROR, E_USER_WARNING)))
    {
        global $error_message, $tries;
        if (!$error_message)
        {
            $error_message = '###RSSREADER###0 <div class="info error">'.htmlentities($errmsg).'</div>';
        }
        $tries ++;
        if ($tries == 1)
        {
            global $url;
            $url = exec('python feedfinder.py "'.escapeshellcmd($url).'" | head -n 1');
            if ($url)
                load_feed($url);
            else
                print $error_message;
        }
        if ($tries > 1)
        {
            print $error_message;
        }
    }
}

function load_feed($url)
{
    global $height;
	$rss = @fetch_rss( $url );
    if ($rss)
    {
        print '###RSSREADER###'.strlen($url). ' '.$url; // info for the widget
        $title = $rss->channel['title'];
        $link = $rss->channel['link'];
        $description = $rss->channel['description'];
        print '<h1>';
        if ($link)
            print '<a href="javascript:widget.openURL(\''.$link.'\');">';
        print htmlentities($title);
        if ($link)
            print '</a>';
        print '</h1><p id="description">';

        if ($description && $description != $title)
            print htmlentities($description);

        print '</p>';

        foreach ($rss->items as $item)
        {
            $link = $item['link'];
            $title = $item['title'];	
            $description = $item['description']; //implode(' ', $item['content']); //$item['description'];	

            //var_dump($item);
            //print htmlentities($description);

            print '<div class="entry" ';
            if ($height)
                print 'style="max-height:'.$height.'px;" ';
            print 'onclick="';

            if ($link)
                print "widget.openURL('".$link."'); return false;";

            print '"><h3>';

            if ($title)
                print htmlentities($title);

            print '</h3>';

            if ($description)
                print $description;

            print '</div>';
        }
    }
}

set_error_handler('error_handler');
load_feed($url);

$c = ob_get_contents();

ob_end_clean();

print utf8_encode($c);

?>
